"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const async_retry_1 = require("./async-retry");
class TestAsyncRetry {
    constructor() {
        this.counter = 0;
    }
    fail() {
        return __awaiter(this, void 0, void 0, function* () {
            ++this.counter;
            throw new Error();
        });
    }
    success() {
        return __awaiter(this, void 0, void 0, function* () {
            return ++this.counter;
        });
    }
    successOnTwo() {
        return __awaiter(this, void 0, void 0, function* () {
            ++this.counter;
            if (this.counter === 1)
                throw new Error();
            return this.counter;
        });
    }
}
__decorate([
    async_retry_1.AsyncRetry(2, 0),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], TestAsyncRetry.prototype, "fail", null);
__decorate([
    async_retry_1.AsyncRetry(2, 0),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], TestAsyncRetry.prototype, "success", null);
__decorate([
    async_retry_1.AsyncRetry(2, 0),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], TestAsyncRetry.prototype, "successOnTwo", null);
describe('AsyncRetry', () => {
    it('should return reject promise with increased counter', () => __awaiter(this, void 0, void 0, function* () {
        const test = new TestAsyncRetry();
        try {
            yield test.fail();
        }
        catch (e) {
            expect(test.counter).toEqual(2);
        }
    }));
    it('should return resolve promise on first attempt', () => __awaiter(this, void 0, void 0, function* () {
        const test = new TestAsyncRetry();
        expect(test.success()).resolves.toBe(1);
    }));
    it('should return resolve promise on second attempt', () => __awaiter(this, void 0, void 0, function* () {
        const test = new TestAsyncRetry();
        expect(test.successOnTwo()).resolves.toBe(2);
    }));
});
//# sourceMappingURL=async-retry.spec.js.map