"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const general_1 = require("../../helpers/general");
function Debounce(timeMs) {
    return general_1.generateFunctionDecorator('Debounce', decorator, timeMs);
}
exports.Debounce = Debounce;
function decorator(fn, timeMs) {
    let timeout;
    return function (...args) {
        timeout && clearTimeout(timeout);
        timeout = setTimeout(() => fn.apply(this, args), timeMs);
    };
}
//# sourceMappingURL=debounce.js.map