"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const general_1 = require("../../helpers/general");
function Memoize(hashFn) {
    return general_1.generateFunctionDecorator('Memoize', decorator, hashFn);
}
exports.Memoize = Memoize;
function decorator(fn, hashFn) {
    const cache = {};
    return function (...args) {
        const key = hashFn ? hashFn.apply(this, args) : JSON.stringify(args);
        if (!general_1.isUndefined(cache[key])) {
            return cache[key].value;
        }
        cache[key] = { value: fn.apply(this, args) };
        return cache[key].value;
    };
}
//# sourceMappingURL=memoize.js.map