"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const memoize_1 = require("./memoize");
const mock = jest.fn(() => 'hash');
class TestMemoize {
    constructor() {
        this.counter = 0;
    }
    count(...args) {
        return ++this.counter;
    }
    asyncCount(...args) {
        return __awaiter(this, void 0, void 0, function* () {
            return ++this.counter;
        });
    }
    countHash(...args) {
        return ++this.counter;
    }
}
__decorate([
    memoize_1.Memoize(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], TestMemoize.prototype, "count", null);
__decorate([
    memoize_1.Memoize(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Promise)
], TestMemoize.prototype, "asyncCount", null);
__decorate([
    memoize_1.Memoize(mock),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], TestMemoize.prototype, "countHash", null);
describe('Memoize', () => {
    it('should memoize values', () => {
        const test = new TestMemoize();
        expect(test.count()).toEqual(1);
        expect(test.count()).toEqual(1);
    });
    it('should not memoize different calls', () => {
        const test = new TestMemoize();
        expect(test.count(1)).toEqual(1);
        expect(test.count(1)).toEqual(1);
        expect(test.count(2)).toEqual(2);
        expect(test.count(1, 2)).toEqual(3);
        expect(test.count(2)).toEqual(2);
    });
    it('should work call hash function', () => {
        const test = new TestMemoize();
        expect(mock).not.toBeCalled();
        test.countHash();
        expect(mock).toBeCalled();
    });
    it('should work with promises', () => __awaiter(this, void 0, void 0, function* () {
        const test = new TestMemoize();
        expect(yield test.asyncCount(1)).toEqual(1);
        expect(yield test.asyncCount(1)).toEqual(1);
        expect(yield test.asyncCount(2)).toEqual(2);
    }));
});
//# sourceMappingURL=memoize.spec.js.map