"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const general_1 = require("../../helpers/general");
function Once() {
    return general_1.generateFunctionDecorator('Once', decorator);
}
exports.Once = Once;
function decorator(fn) {
    let called = false;
    let returnValue;
    return function (...args) {
        if (called) {
            return returnValue;
        }
        called = true;
        return (returnValue = fn.apply(this, args));
    };
}
//# sourceMappingURL=once.js.map