"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function isObject(val) {
    return typeof val === 'object' && val !== null && !Array.isArray(val);
}
exports.isObject = isObject;
function isUndefined(val) {
    return typeof val === 'undefined';
}
exports.isUndefined = isUndefined;
function generateFunctionDecorator(name, decorator, ...args) {
    return (target, propertyKey, descriptor) => {
        if (descriptor.value != null) {
            descriptor.value = decorator(descriptor.value, ...args);
        }
        else if (descriptor.get != null) {
            descriptor.get = decorator(descriptor.get, ...args);
        }
        else {
            throw `Only put a @${name}() decorator on a method or get accessor.`;
        }
    };
}
exports.generateFunctionDecorator = generateFunctionDecorator;
//# sourceMappingURL=general.js.map