export interface Node<T> {
    prev?: Node<T>;
    next?: Node<T>;
    value: T;
    key: string;
}
export declare class LRU<T> {
    private maxRecords;
    private totalStorage;
    private cache;
    private head;
    private tail;
    constructor(maxRecords: number);
    get(key: string): T | undefined;
    insert(key: string, value: T): void;
    remove(key: string): void;
    toString(): string;
    private add;
}
